<div class="attribute-value attribute-value-{{dasherize @name}} {{if this.hasFocus 'has-focus'}}" ...attributes
  {{did-update this.resetValue @value}}>
  {{#if this.isLoading}}
    <span class="float-end pe-2 pt-1 m-0">
      <FaIcon @icon="spinner" @spin={{true}} @size="xs" />
    </span>
  {{/if}}

  <TextWithOptions @options={{@colValue.data.labels}} @deviceSize={{@deviceSize}} @tag="label"
    data-name={{@colValue.name}} data-type="label" data-path="{{@path}}.data.labels" data-gid={{@colValue.gid}}
    class="form-label" for={{this.inputId}}>

    {{#if @question}}
      {{@question}}
    {{else if @name}}
      {{@name}}
    {{else if @key}}
      {{@key}}
      {{! deprecated }}
    {{/if}}

    {{#if @isRequired}}
      <span class="text-danger required">*</span>
    {{/if}}
  </TextWithOptions>

  {{#if @help}}
    <div class="input-group-help mb-1 text-secondary">
      {{@help}}
    </div>
  {{/if}}

  {{! template-lint-disable require-input-label }}
  {{#if (eq @format "boolean")}}
    <Attributes::ValueBoolean @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @onChange={{this.change}} />
  {{else if (eq @format "boolean-required")}}
    <Attributes::ValueBooleanRequired @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @onChange={{this.change}} />
  {{else if (eq @format "long text")}}
    <Attributes::ValueLongText @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @onFocusIn={{this.focusIn}}
      @onFocusOut={{this.longTextFocusOut}} @onChange={{this.change}} />
  {{else if (eq @format "map list")}}
    <Attributes::ValueMapList @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @options={{@maps}}
      @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}} @onChange={{this.change}} />
  {{else if (eq @format "options")}}
    <Attributes::ValueOptions @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @options={{@options}}
      @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}} @onChange={{this.change}} />
  {{else if (eq @format "options with other")}}
    <Attributes::ValueOptionsOther @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @options={{@options}}
      @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}} @onChange={{this.change}} />
  {{else if (eq @format "integer")}}
    <Attributes::ValueInteger @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @focus-in={{this.focusIn}}
      @focus-out={{this.focusOut}} @onChange={{this.change}} />
  {{else if (eq @format "date")}}
    <Attributes::ValueDate @isEditor={{@isEditor}} id={{this.inputId}} @value={{this.tmpValue}} @onChange={{this.change}}
      @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}} />
  {{else if (eq @format "stream discharge")}}
    <Input::StreamDischarge @value={{this.tmpValue}} @onChange={{this.change}} @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}}/>
  {{else if (eq @format "geo json")}}
    <Input::GeoJson id={{this.inputId}} @isEditor={{@isEditor}} @value={{this.tmpValue}} @typeOptions={{@options}} @colValue={{@colValue}} @path={{@path}}
      @deviceSize={{@deviceSize}} @positionDetails={{@positionDetails}} @state={{@state}} @campaign={{@campaign}}
      @onChange={{this.change}} @onFocusIn={{this.focusIn}} @onFocusOut={{this.focusOut}} />
  {{else if (eq @format "pictures")}}
    <Input::ImageList @isEditor={{@isEditor}} @value={{this.tmpValue}} @onChange={{this.change}} @onFocusIn={{this.focusIn}}
      @onFocusOut={{this.focusOut}} />
  {{else if (eq @format "sounds")}}
    <Input::SoundList @isEditor={{@isEditor}} @value={{this.tmpValue}} @onChange={{this.change}} @onFocusIn={{this.focusIn}}
      @onFocusOut={{this.focusOut}} />
  {{else if (eq @format "icons")}}
    <Input::Icons::ListToggle @isEditor={{@isEditor}} {{did-insert this.loadIcons}} @list={{this.icons}} @value={{this.tmpValue}}
      @onChange={{this.change}} {{on "focusin" this.focusIn}} {{on "focusout" this.focusOut}} />
  {{else}}
    {{#if this.disabled}}
      <div class="value-read-only">
        {{this.tmpValue}}
      </div>
    {{else}}
      <Input id={{this.inputId}} class="form-control" @type={{@format}} @value={{this.tmpValue}}
        {{on "focusin" this.focusIn}} {{on "focusout" this.focusOut}} {{on "change" this.changeInput}} />
    {{/if}}
  {{/if}}
</div>